﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace viperPS
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
            AboutContent();
        }

        /// <summary>
        /// Adds content to the about section.
        /// </summary>
        private void AboutContent()
        {
            StringBuilder aboutTxt = new StringBuilder();
            aboutTxt.AppendLine("INTRODUCTION");
            aboutTxt.AppendLine("This application was developed as part of a free learning tutorial that illustrates a method of creating a Forms Application (.Net 4.7.2+) that interfaces with PowerShell on a local machine and remote machines to perform a variety of actions in a GUI interface.  As part of a tutorial this application is not intended to be used outside of a learning lab setting.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("::USAGE::");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Target Machine/IP");
            aboutTxt.AppendLine("When you start the application, the context is automatically set to your local machine (::1, 127.0.0.1 is also considered local).  If you want to target another machine, specify that machine's host name (commonly referred to as computer name) or IP address.  The IP address can be v4 or v6.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Target User");
            aboutTxt.AppendLine("When you start the application, the context is automatically set to the user account you are using to run the application.  This field is used in conjunction with \"Target Machine/IP\" when an action is completed that requires a specific user on a machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Impersonate");
            aboutTxt.AppendLine("The \"Username\" and \"Password\" fields allow you to enter the credentials to use when starting this application so that it runs under that account context (this allows you to log into a computer with one account but use this application with a different account).  For example, you may want to start this application using an Administrator account so that you can complete actions that require additional access/permissions on the local machine or a remote machine.  The \"Username\" field will recognize a domain linked account such as \"AD-DOMAIN\\user\" or just \"user\"; in the case of the latter the application assumes the context of the environment used when you logged in to the computer.  The \"Password\" field accepts the password of the \"Username\" account; handling of password input is completed by a native Windows security control specifically built to keep passwords confidential and encrypted.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Lock Machine");
            aboutTxt.AppendLine("This allows you to lock the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Log Off User");
            aboutTxt.AppendLine("This allows you to log off users of the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Restart Machine");
            aboutTxt.AppendLine("This allows you to restart the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get User SID");
            aboutTxt.AppendLine("This allows you to get the SID of the logged in user of the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Disk Space");
            aboutTxt.AppendLine("This allows you to get the logical disk information of the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Machine Name");
            aboutTxt.AppendLine("This allows you to get the host name (or computer name) of the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Machine IP");
            aboutTxt.AppendLine("This allows you to get all of the network interface IPv4 and IPv6 address(s) of the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Ping Machine");
            aboutTxt.AppendLine("This allows you to send a single ICMP ping to the targeted machine.  This feature automatically converts the status codes to text so you don't need to look up status codes to determine what they are referring to.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Machine Info");
            aboutTxt.AppendLine("This allows you to get a wide range of information about the targeted machine (it could take up to a minute for this action to finish).  The information includes IP address(s) and equivalent MAC address(s), machine operating system and serial number, hardware information, processor information and organizational unit.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Machine Processes");
            aboutTxt.AppendLine("This allows you to get a list of processes attached to a specific user of the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Traceroute Machine");
            aboutTxt.AppendLine("This allows you to complete a traceroute to the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Logged In User");
            aboutTxt.AppendLine("This allows you to get the user account logged into the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Machine Uptime");
            aboutTxt.AppendLine("This allows you to get the amount of time (several different measurements) the targeted machine has been on.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Remote Assistance to Machine");
            aboutTxt.AppendLine("This allows you to start a remote assistance session with the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Remote to Machine");
            aboutTxt.AppendLine("This allows you to start a RDP session with the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Computer Management");
            aboutTxt.AppendLine("This allows you to bring up the Computer Management pane (includes things like System Tools - Task Scheduler - Event Viewer - Local Users and Groups - Performance - Device Manager, Storage - Disk Management, and, Services and Applications.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Clear CSC Offline Files");
            aboutTxt.AppendLine("This allows you to clear the CSC cache on the targeted machine.  This action clears the physical disk space used by CSC and resets the database; this means that any synchronization paths will have to be re-added manually.  The targeted computer will have to be manually restarted (there is a button for that in this application) after this action completes.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Machine PS Version");
            aboutTxt.AppendLine("This allows you to get the PowerShell version installed on the targeted computer.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Run Remote Command");
            aboutTxt.AppendLine("This allows you to open a command window for the traditional command-line or PowerShell on the targeted machine.  Once opened then you can enter commands.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Machine Event Log");
            aboutTxt.AppendLine("This allows you to retrieve the most recent 100 error log entries from the standard logs \"Application\", \"Security\" and \"System\" from the targeted machine.  It should be noted that retrieval of the \"Security\" log, even on the local machine, require more permissions than those commonly granted to a standard user account.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Get Services");
            aboutTxt.AppendLine("This allows you to retrieve all of the services on the targeted machine.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Restart Services");
            aboutTxt.AppendLine("This allows you to enter the name of the service that you want to restart (whether it is running or stopped) on the targeted machine.  It should be noted that restarting a service, even on a local machine, require more permissions than those commonly granted to a standard user account.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Run File on Machines");
            aboutTxt.AppendLine("This allows you to select a standard text file - which contains the host name (computer name) of machines (one per line) that you want to run a bat or ps1 file on.  The second field allows you to select a bat or ps1 script file to run on the targeted machines.  If the script fails to run on any machines, those machines will be saved to a file called \"FailedComputers.txt\" in the same folder as where the standard text file is located which contains the list of machines.  To conserve resources, windows to each machine are not created.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Run File on Machine");
            aboutTxt.AppendLine("This allows you to run a bat or ps1 file on the targeted machine.  A window is generated so that you can observe the execution of the script.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Request Output");
            aboutTxt.AppendLine("Completion of an action generates output which is displayed here.  The copy button allows you to copy that output to the clipboard.");
            aboutTxt.AppendLine("");
            aboutTxt.AppendLine("Request Error Output");
            aboutTxt.AppendLine("When an error is encountered, that information is displayed here.  The copy button allows you to copy that output to the clipboard.");
            txtBoxAbout.Text = aboutTxt.ToString();
        }
    }
}
