﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
/* For WPF PasswordBox User Control */
using System.Security;

namespace viperPS
{
    /// <summary>
    /// Interaction logic for PwdUserControl1.xaml.
    /// This is the class for handling the WPF User Control (PasswordBox) that is added to Form1.cs (after being added the project and the project is built so that the user control appears in the Toolbox to drag onto the Form1 designer surface).
    /// The WPF User Control was added to the project by right-clicking on the project, Adding and selecting WPF User Control.
    /// In this case, the following files were added to the project as a result:
    /// PwdUserControl1.xaml - this dictates the visualization of the control.  The WPF PasswordBox was added between the <Grid></Grid> tags.
    /// PwdUserControl1.xaml.cs - this dictates the code-behind for the WPF PasswordBox; in this case the change event.
    /// </summary>
    public partial class PwdUserControl1 : UserControl
    {
        public PwdUserControl1()
        {
            InitializeComponent();
            passwordBoxElement.PasswordChanged += PasswordBoxElement_PasswordChanged;
        }

        /// <summary>
        /// Tracks changes made to the WPF PasswordBox User Control.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private static void PasswordBoxElement_PasswordChanged(object sender, RoutedEventArgs e)
        {
            WpfSecurePassword = ((PasswordBox)sender).SecurePassword;
        }

        /// <summary>
        /// Allows the SecurePassword in PasswordBox to be accessible.
        /// </summary>
        public static SecureString WpfSecurePassword
        {
            get; set;
        }
    }
}
